<?php
/**
 * Session.php
 * 
 * The Session class is meant to simplify the task of keeping
 * track of logged in users and also guests.
 *
 * Written by: Jpmaster77 a.k.a. The Grandmaster of C++ (GMC)
 * Last Updated: August 19, 2004
 * Modified by: Arman G. de Castro, October 3, 2008
 * email: decastroarman@hotmail.com
 */

  if (!class_exists('Session') ) {
class Session
{
   var $username;     //Username given on sign-up
   var $userid;       //Random value generated on current login
   var $userlevel;    //The level to which the user pertains
   var $time;         //Time user was last active (page loaded)
   var $logged_in;    //True if user is logged in, false otherwise
   var $userinfo = array();  //The array holding all user info
   var $url;          //The page url current being viewed
   var $referrer;     //Last recorded site page viewed
   var $firma;
   var $dbExt;
   var $dbLang;
   var $dbServer;
   var $site_maintenance;
   var $gallery_start;
   var $dbhandle;
   /**
    * Note: referrer should really only be considered the actual
    * page referrer in process.php, any other time it may be
    * inaccurate.
    */

   /* Class constructor */
   function Session(){
      $this->time = time();
       if(!isset($_SESSION)) 
    { 
       $this->startSession();       
       $_SESSION['timer'] = time();
        //session_start(); 
    } 
     
   }

   /**
    * startSession - Performs all the actions necessary to 
    * initialize this session object. Tries to determine if the
    * the user has logged in already, and sets the variables 
    * accordingly. Also takes advantage of this page load to
    * update the active visitors tables.
    */
   function startSession(){
      global $database;  //The database connection
      session_start();   //Tell PHP to start the session      
      $dr=str_replace("box/include","",dirname(__FILE__)); 
      $titles_bkg_colors="000033";
      $titles_front_color="ffffff";
      $error_reporting=0;
      if (file_exists($dr."config/config.php"))  include_once($dr."config/config.php");
  

define('dbServer',$dbServer);
define('dbUser',$dbUser);
define('dbPass',$dbPass);
define('dbDatabase',$dbDatabase);
define('dbExt',$dbExt);
define('LANG',$dbLang); 
define('site_maintenance',$site_maintenance);
if (isset( $_COOKIE['jezik']))  (LANG==$_COOKIE['jezik']); 
else {setcookie("jezik", LANG); header("Location:index.php");exit;}
define('current_template',$template_name.'.php');
define('site_web_adress',$home_page);
define ("titles_bkg_colors",$titles_bkg_colors);
define("titles_front_color",$titles_front_color);
define("errorr_reporting",$error_reporting);
//$database = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error($dbhandle));    

 if(!isset($_SESSION['gallery_start'])){
 $this->gallery_start= $_SESSION['gallery_start']=0;
 }

      
      /* Set referrer page */
      if(isset($_SESSION['url'])){
         $this->referrer = $_SESSION['url'];
      }else{
         $this->referrer = "/";
      }

      /* Set current url */
      $this->url = $_SESSION['url'] = $_SERVER['PHP_SELF'];
   }

function daj_url(){
    
          if(isset($_SESSION['url'])){
         $this->referrer = $_SESSION['url'];
         return $this->referrer ;
      }else{
         $this->referrer = "/";
          return $this->referrer ;
  }
}
  
function daj_galeriju(){
 if(!isset($_SESSION['gallery_start'])){
 $this->gallery_start= $_SESSION['gallery_start']=0;
}
else {
     $this->gallery_start= $_SESSION['gallery_start'];
    }
    return $this->gallery_start;
}


function daj_store(){
 if(!isset($_SESSION['store_start'])){
 $this->store_start= $_SESSION['store_start']=0;
}
else {
     $this->store_start= $_SESSION['store_start'];
    }
    return $this->store_start;
}

function return_con(){
         $dbhandle = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error($dbhandle));    
       //     mysqli_select_db($dbhandle) or die ("Error selecting specified database on mysql server: ".mysql_error());
        return $dbhandle;
        }

function upis_galerije($val){
  (gallery_start==$val);
    return  gallery_start;
    }
  
   /**
    * checkLogin - Checks if the user has already previously
    * logged in, and a session with the user has already been
    * established. Also checks to see if user has been remembered.
    * If so, the database is queried to make sure of the user's 
    * authenticity. Returns true if the user has logged in.
    */
   function checkLogin(){
      global $database;  //The database connection
      /* Check if user has been remembered */
      if(isset($_COOKIE['cookname']) && isset($_COOKIE['cookid'])){
         $this->username = $_SESSION['username'] = $_COOKIE['cookname'];
         $this->userid   = $_SESSION['userid']   = $_COOKIE['cookid'];
      }
}
   

   /**
    * generateRandID - Generates a string made up of randomized
    * letters (lower and upper case) and digits and returns
    * the md5 hash of it to be used as a userid.
    */
   function generateRandID(){
      return md5($this->generateRandStr(16));
   }
   
   /**
    * generateRandStr - Generates a string made up of randomized
    * letters (lower and upper case) and digits, the length
    * is a specified parameter.
    */
   function generateRandStr($length){
      $randstr = "";
      for($i=0; $i<$length; $i++){
         $randnum = mt_rand(0,61);
         if($randnum < 10){
            $randstr .= chr($randnum+48);
         }else if($randnum < 36){
            $randstr .= chr($randnum+55);
         }else{
            $randstr .= chr($randnum+61);
         }
      }
      return $randstr;
   }
}
function strip_html_tagove( $text )
{
    $text = preg_replace(
        array(
          // Remove invisible content
            '@<head[^>]*?>.*?</head>@siu',
            '@<style[^>]*?>.*?</style>@siu',
            '@<script[^>]*?.*?</script>@siu',
            '@<object[^>]*?.*?</object>@siu',
            '@<embed[^>]*?.*?</embed>@siu',
            '@<applet[^>]*?.*?</applet>@siu',
            '@<noframes[^>]*?.*?</noframes>@siu',
            '@<noscript[^>]*?.*?</noscript>@siu',
            '@<noembed[^>]*?.*?</noembed>@siu',
          // Add line breaks before and after blocks
            '@</?((address)|(blockquote)|(center)|(del))@iu',
            '@</?((div)|(h[1-9])|(ins)|(isindex)|(p)|(pre))@iu',
            '@</?((dir)|(dl)|(dt)|(dd)|(li)|(menu)|(ol)|(ul))@iu',
            '@</?((table)|(th)|(td)|(caption))@iu',
            '@</?((form)|(button)|(fieldset)|(legend)|(input))@iu',
            '@</?((label)|(select)|(optgroup)|(option)|(textarea))@iu',
            '@</?((frameset)|(frame)|(iframe))@iu',
        ),
        array(
            ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',"$0", "$0", "$0", "$0", "$0", "$0","$0", "$0",), $text );
  
    // you can exclude some html tags here, in this case B and A tags       
    return strip_tags( $text , '<b><a>' );
}

/**
 * Initialize session object - This must be initialized before
 * the form object because the form uses session variables,
 * which cannot be accessed unless the session has started.
  */
 function get_first_page($lang,$page=1){
     $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
$link->set_charset("utf8");
$sh=1;
 $cdquery="SELECT * FROM site_public WHERE lang='$lang' AND first_page='$page' AND show_it='$sh' ORDER BY position ASC ";
  $cdresult=$link->query($cdquery) or die ("TEMPLATE:Query to get data from site_public failed: ".mysqli_error($link));
  mysqli_close($link);
     return   $cdresult;
}
 function get_all_pages($lng,$sw){
      $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error($dbhandle));    
   switch($sw){
    case 0: $cdquery="SELECT * FROM site_public WHERE lang='$lng'"; break;
      case 1: $cdquery="SELECT * FROM site_public WHERE lang='$lng' ORDER BY name ASC"; break;
}
     $link->set_charset("utf8");
//mysql_query("SET NAMES utf8");
 $cdresult=$link->query($cdquery) or die ("TEMPLATE:Query to get data from site_public failed: ".mysqli_error($link));
  mysqli_close($link);
     return   $cdresult;
}

 function get_page($lng,$page,$sh){
  
     $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
 if ($sh==3) { $cdquery="SELECT * FROM site_public WHERE lang='$lng' AND id='$page'  ORDER BY position ASC";}
else {  $cdquery="SELECT * FROM site_public WHERE lang='$lng' AND id='$page' AND show_it='$sh' ORDER BY position ASC"; }
      $link->set_charset("utf8");
  $cdresult=$link->query($cdquery) or die ("TEMPLATE:Query to get data from site_public failed: ".mysqli_error($link));
    mysqli_close($link);
     return   $cdresult;
}
 function delete_page($page){
     $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
      $R= $link->query("DELETE  FROM site_public WHERE id='$page'") ;
      if (!$R) die("Error deleting page:".$page."  Error : ".mysqli_error($link));
    mysqli_close($link);
}

 function read_parent($menu, $lang){
     $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result =  $link ->query("SELECT * FROM $menu WHERE lang='$lang' AND parent_id=0 AND sistem=0") or die(mysqli_error( $link ));
    $link->set_charset("utf8");
mysqli_close( $link );
return  $result;  
    }
  function read_all_menu_items($menu, $lang){
     $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
  $result = $link->query("SELECT * FROM $menu WHERE lang='$lang'") or die(mysql_error($link));
mysqli_close($link);
return  $result;  
}

function delete_menu_item($menu, $id){
        $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
     $R= $link->query("DELETE  FROM $menu WHERE id='$id'  AND sistem=0") ;
         mysqli_close($link);
         if (!$R) {'Error deleting menu item: '.mysqli_error($link); exit;}
        return "OK";
    }

function publish_menu_item($menu, $id, $published, $lang){
              $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
    $link->query("UPDATE $menu SET show_it='$published' WHERE id='$id' AND lang='$lang'") or die(mysqli_error($link));
         mysqli_close($link);
}
function rename_menu_item($menu, $id, $new_name, $lang){
           $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
 $link->query("UPDATE $menu SET menu_name='$new_name' WHERE id='$id' AND lang='$lang'") or die(mysqli_error( $link));
         mysqli_close($link);
}
function get_published($table, $id, $lang){
           $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result = $link->query("SELECT * FROM $table WHERE id='$id' AND lang='$lang'") or die(mysqli_error($link));
$prod_obj = mysqli_fetch_object($result );
mysqli_close($link);
return  $prod_obj->show_it;
}
function get_selected_menu($table, $id, $lang){
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result = $link->query("SELECT * FROM $table WHERE id='$id' AND lang='$lang'") or die(mysqli_error($link));
$prod_obj = mysqli_fetch_object($result );
mysqli_close($link);
return  $prod_obj;
}

function get_selected_menu_group($id){
    //echo "*** ID ***".$id;
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result = $link->query("SELECT * FROM menu WHERE id='$id'") or die(mysqli_error($link));
$prod_obj = mysqli_fetch_object($result );
mysqli_close($link);
return  $prod_obj->name;
}
function get_languages(){
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result =  $link->query("SELECT * FROM language ORDER BY longlang ASC") or die(mysqli_error( $link));
mysqli_close( $link);
return  $result;
}

function language_exists($lang){
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
  $sql = "SELECT * FROM language WHERE lang='$lang'";
$result = $link->query($sql) or die(mysqli_error( $link));
$numrows = $result->num_rows;
mysqli_close( $link);
return  $numrows;
}

function language_adress($lang){
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
  $sql = "SELECT * FROM language WHERE lang='$lang'";
$result = $link->query($sql) or die(mysqli_error( $link));
$prod_obj = mysqli_fetch_object($result );
mysqli_close( $link);
return  $prod_obj;
}

function get_slideshow(){
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result =  $link->query("SELECT * FROM slideshow ORDER BY id ASC") or die(mysqli_error( $link));
mysqli_close( $link);
return  $result;
}
function get_slideshow_text($pid,$ln){
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result =  $link->query("SELECT * FROM slideshow_text WHERE pict_id='$pid' AND lang='$ln' ORDER BY id ASC") or die(mysqli_error( $link));
$rr=mysqli_fetch_object($result );
mysqli_close( $link);
return  $rr;
}

function get_selected_slideshow($id){
          $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result = $link->query("SELECT * FROM slideshow WHERE id='$id'") or die(mysqli_error($link));
$prod_obj = mysqli_fetch_object($result );
mysqli_close($link);
return  $prod_obj;
}

function publish_lang($val, $id){
           $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
       $link->query("UPDATE language SET show_it='$val' WHERE id='$id'") or die(mysqli_error( $link));
         mysqli_close( $link);
}

  function read_all_menu_groups(){
           $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
 $result = $link->query("SELECT * FROM menu ORDER BY name ASC") or die(mysqli_error($link));
mysqli_close($link);
return  $result;  
}
function find_menu_group($idg){
           $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result = $link->query("SELECT * FROM menu_asotiation WHERE id='$idg'") or die(mysqli_error($link));
$prod_obj = mysqli_fetch_object($result );
mysqli_close($link);
return  $prod_obj->name;
}

  function read_side_menu_groups($side){
  $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result = $link->query("SELECT * FROM menu where position='$side' AND show_it=1 ORDER BY vorder ASC, name ASC") or die(mysqli_error( $link));
mysqli_close( $link);
return  $result;  
}

  function get_menu_name_asotiacion($name,$lang){
  $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
$result = $link->query("SELECT * FROM menu_asotiation where name='$name' AND lang='$lang'") or die(mysqli_error( $link));
$prod_obj = mysqli_fetch_object($result );
mysqli_close( $link);
return  $prod_obj->asociation; 
}

  function read_all_menu_asociations($lang){
           $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
 $result = $link->query("SELECT * FROM menu_asotiation WHERE lang='$lang' ORDER BY name ASC") or die(mysqli_error($link));
mysqli_close($link);
return  $result;  
}

function delete_menu_group($table_id){
    $t_name=find_menu_group($table_id);
  $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
 $t_name=str_replace(" ","_",$t_name);
   $result = $link->query("DROP TABLE $t_name");
   if (!$result){ echo 'ERROR deleting menu group: '.$t_name.' Error= '.mysqli_error($link); exit();}
$t=$link->query("DELETE  FROM menu WHERE name='$t_name'") ;
 if (!$t){ echo 'ERROR deleting menu name from catalog: '.$t_name.' Error= '.mysqli_error($link); exit();}
$r=$link->query("DELETE  FROM menu_asotiation WHERE name='$t_name'");
 if (!$r){ echo 'ERROR deleting menu name from menu_asotiation: '.$t_name.' Error= '.mysqli_error($link); exit();}
mysqli_close( $link);
 return "OK";
}

function vrati_val($vals){
          $pos = strpos($vals, ",");
      $find=substr($vals, 1, $pos-1);  
      return str_replace($find,"NULL",$vals);
      }

function &backup_tables($tables = '*', $send_lang, $full_lang, $full_adres){
  $data = "\n/*---------------------------------------------------------------".
          "\n  SQL DB BACKUP ".date("d.m.Y H:i")." ".
          "\n  NEW LANG: {$send_lang}".
          "\n  TABLES: {$tables}".
          "\n  ---------------------------------------------------------------*/\n";
   $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
  $link->set_charset("utf8");
  if($tables == '*'){ //get all of the tables
    $tables = array();
    $result = $link->query("SHOW TABLES");
    while($row = mysqli_fetch_row($result)){
      $tables[] = $row[0];
    }
  }else{
    $tables = is_array($tables) ? $tables : explode(',',$tables);
  }

  foreach($tables as $table){
    $data.= "\n/*---------------------------------------------------------------".
            "\n  TABLE: `{$table}`".
            "\n  ---------------------------------------------------------------*/\n";           

    $result = $link->query("SELECT * FROM `{$table}` WHERE lang='$send_lang'");
    $num_rows = mysqli_num_rows($result);    

    if($num_rows>0){
      $vals = Array(); $z=0;
      for($i=0; $i<$num_rows; $i++){
        $items = mysqli_fetch_row($result);
        $vals[$z]="(";
        for($j=0; $j<count($items); $j++){
         if (isset($items[$j])) { $vals[$z].= "'".mysqli_real_escape_string($link , $items[$j])."'"; } else { $vals[$z].= "NULL"; }
          if ($j<(count($items)-1)){ $vals[$z].= ","; }
        }
        $vals[$z].= ")"; 
        $vals[$z]=vrati_val($vals[$z]);
        $z++;
      }
      $data.= "INSERT INTO `{$table}` VALUES ";      
      $data .= "  ".implode(";\nINSERT INTO `{$table}` VALUES ", $vals).";\n";
    }
}

$dats="(NULL,'$send_lang','$full_lang','$full_adres', '1')";
  $data.= "\n/*---------------------------------------------------------------".
            "\n  TABLE: LANGUAGE -------------------------------*/".
            "\nINSERT INTO `language` VALUES ".$dats.";\n";          
  mysqli_close( $link );
  return $data;
}

function run_sql_file($filename){
  $link = mysqli_connect( dbServer, dbExt.dbUser,dbPass,dbExt.dbDatabase) or die ("VARS: Error connecting to mysql server: ".mysqli_error( $link ));    
// Temporary variable, used to store current query
$templine = '';
// Read in entire file
$lines = file($filename);
// Loop through each line
foreach ($lines as $line)
{
    // Skip it if it's a comment
    if (substr($line, 0, 2) == '--' || $line == '')
        continue;
 
    // Add this line to the current segment
    $templine .= $line;
    // If it has a semicolon at the end, it's the end of the query
    if (substr(trim($line), -1, 1) == ';')
    {
          $link->set_charset("utf8");
        $link->query($templine) or print('Error performing query \'<strong>' . $templine . '\': ' . mysqli_error($link) . '<br /><br />');
        // Reset temp variable to empty
        $templine = '';
    }
}
return "OK";
mysqli_close($link);
}
// Here's a startsWith function
function startsWith($haystack, $needle){
    $length = strlen($needle);
    return (substr($haystack, 0, $length) === $needle);
}

$session = new Session;

/* Initialize form object */
}
?>
